=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

# Notes: remove rpath due to Debian policy
override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_SKIP_BUILD_RPATH=TRUE \
	  -DFORCE_SKIP_RPATH=1 \
	  -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
	  -DCMAKE_SKIP_RPATH=TRUE \
	  -DFCLIB_WITH_MERIT_FUNCTIONS=ON \
	  -DFCLIB_HEADER_ONLY=OFF \
	  -DHARDCODE_NOT_HEADER_ONLY=ON \
	  -DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/FCLib
