=== debian/changelog ===
fclib (3.0.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.2.1
  * Remove hard-coded lib and lib-dev dependencies from lib package.
    Closes: #914493.

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Dec 2018 10:44:49 +0800

fclib (3.0.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #894120)

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 26 Mar 2018 12:40:15 -0300
