=== debian/tests/control ===
Tests: unittests-pkgconfig
Depends: libfclib-dev, build-essential, pkg-config

Tests: unittests-cmake
Depends: libfclib-dev, build-essential, cmake
