## fclib 3.1.0%2Bdfsg

=== debian/changelog ===
fclib (3.1.0+dfsg-2build1) impish; urgency=medium

  * No-change upload to drop reference to libpthread.so.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Aug 2021 12:03:34 +0200

fclib (3.1.0+dfsg-2) unstable; urgency=medium

  * Patch wrong argument to cs_transpose which leads to segfault.
    (Closes: #927761)

 -- Stephen Sinclair <radarsat1@gmail.com>  Thu, 11 Jun 2020 21:29:28 +0000

fclib (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Change paths to correspond with new CMake install location.
  * Make unittests-cmake test the FCLIB exported target.
  * Hardcode path to cs.h from libsuitesparse-dev.
  * Add Upstream-Contact info to debian/copyright.
  * Increase policy standard to 4.5.0.
    + d/copyright: add wildcard for Files-Excluded
  * Add Build-Depends-Package field to symbols files.

 -- Stephen Sinclair <radarsat1@gmail.com>  Tue, 19 May 2020 11:36:51 +0000
