=== debian/changelog ===
fclib (3.1.0+dfsg-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:14:03 +0000

fclib (3.1.0+dfsg-3build1) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:55:14 +0000

fclib (3.1.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtest regression due to CMake warning (Closes: #1040718)

 -- Timo Röhling <roehling@debian.org>  Sun, 23 Jul 2023 21:28:17 +0200
