=== debian/rules ===
--- 
+++ 
@@ -22,4 +22,4 @@
 	  -DFCLIB_WITH_MERIT_FUNCTIONS=ON \
 	  -DFCLIB_HEADER_ONLY=OFF \
 	  -DHARDCODE_NOT_HEADER_ONLY=ON \
-	  -DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/FCLib
+	  -DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/FCLIB
