=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
  https://github.com/FrictionalContactLibrary/fclib/releases .*/v?(\d+\.\d+.\d+)\.tar\.gz
